#ifndef DLMZONE_H_
#define DLMZONE_H_

#include <cstring>
#include <list>

#include "DLPolygon.h"

// from Doclib
#include "DLRectShape.h"

class DLMZone {

	// member variable
private:
	bool bImageReady;
	
	bool bRLE;

protected:
	int zid;
	string lid;
	string type;
	DLRectShape rect;
	vector<DLZone*> zones;

	DLImage image;

public:

	// member function
private:
	int transPosX( int x, int y, double angle );
	int transPosY( int x, int y, double angle );

	int cntONPixel();
	int cntONPixel( DLRectShape rect );
	int cntOverlapPixel( DLMZone& zone );

	string cvIntToStr(int num);

	void getRLEList( string rle, vector<int>& row, vector<int>& col, vector<int>& len );

	DLRectShape getInterRect( DLRectShape src, DLRectShape tgt );

	DLPolygon getPolyFromPoly( const DLZone * zone );
	DLPolygon getPolyFromOri( const DLZone * zone );
	DLPolygon getPolyFromRect( const DLZone * zone );

protected:
	DLRectShape calRect( const DLZone * zone );
	DLPolygon calPolygon( const DLZone * zone );

public:
	DLMZone();
	DLMZone( int zid, string lid, string type, DLZone * zone, bool brle);
	~DLMZone();
	// DLMZone& operator=( const DLMZone& zone );

	void addZone( DLZone * zone );
	void addZone( DLMZone * zone );

	int getID() const;
	string getLineID() const;
	string getType() const;
	DLRectShape getRect() const;
	int getZoneCnt() const;
	vector<DLZone*> getZoneList() const;
	DLZone* getZone( int i );
	string getZoneListStr() const;

	string getRunLengthCode();

	DLImage getZoneImage();

	bool isOverlap( DLRectShape rect );

	double getMatchScore( DLMZone & zone );
	double getCoverScore( DLMZone & zone );
};


#endif /*DLMZONE_H_*/
