#ifndef DLPOLYGON_H_
#define DLPOLYGON_H_

// from Doclib
#include "DLRectShape.h"

// Simple polygon class for this project

class DLPolygon {
	// member variable;
private:
	
	static const int MIN_LENGTH = 3;
	
protected:
	
	DLRectShape bounds;
	
	int npoints;
	
	int * xpoints;
	int * ypoints;
	
	//list<int> xpointsList;
	//list<int> ypointsList;
	
public:
	
	// member function;
private:
	
	int min( int x, int y );
	int max( int x, int y );
	
protected:
	
	bool boundCheck( double x, double y );
	void calculateBounds();	
	
public:
	
	DLPolygon();
	
	// copy constructor
	DLPolygon( const DLPolygon & poly );
	
	DLPolygon( int * xpoints, int * ypoints, int npoints );
	
	~DLPolygon();
	
	DLPolygon& operator=( const DLPolygon & poly );
	
	//list<int> getXpoints() const;
	//list<int> getYpoints() const;
	
	int * getXpoints() const;
	int * getYpoints() const;
	int getSize() const;
	bool contains(double x, double y);
	bool contains(int x, int y);
	void invalidate() { this->npoints = 0; }
	DLRectShape getBounds() const;	
};

#endif /*DLPOLYGON_H_*/
