#pragma once

#include "xml.h"

// from Doclib
#include "DLDocument.h"
#include "DLPage.h"
#include "DLZone.h"
#include "DLTagList.h"

#include <vector>
#include <cstring>

using namespace std;

class DLxml
{
public:
	DLxml( DLDocument inputDocument, string strFilename );
	DLxml();

	bool dlSaveToXmlFile( string filename );
	DLDocument dlReadFromXmlFile( string filename, string filepath );

	~DLxml(void);

private:
	xml xmlDocTree;
	DLDocument dlDoc;

	void traverseXML(xml &xmlDocTree, DLZone *zone );
	void traverseSubtree( DLZone* zones, int cnt, xml& xmlDocTree );

	vector <string> staticDocumentAttributes;
	vector <string> staticPageAttributes;
	vector <string> staticZoneAttributes;

	bool validatePolygon( DLZone * zone, int width, int height );
};
